%define debug_package %{nil}

Name: flightctl
Version: v0.2.1
Release: 5.20241016072041382296.pr588.176.gffc19a8%{?dist}
Summary: Flightctl CLI

License: XXX
URL: https://github.com/flightctl/flightctl
Source0: flightctl-v0.2.1.tar.gz

BuildRequires: golang
BuildRequires: make
BuildRequires: git
BuildRequires: openssl-devel
Requires: openssl

%description
Flightctl is a command line interface for managing edge device fleets.


%package agent
Summary: Flightctl Agent
%description agent
Flightctl Agent is a component of the flightctl tool.

%prep
%setup -q -n flightctl-v0.2.1

%build

# if this is a buggy version of go we need to set GOPROXY as workaround
# see https://github.com/golang/go/issues/61928
GOENVFILE=$(go env GOROOT)/go.env
if [[ ! -f "{$GOENVFILE}" ]]; then
    export GOPROXY='https://proxy.golang.org,direct'
fi
make build

%install
mkdir -p %{buildroot}/usr/bin
cp bin/flightctl %{buildroot}/usr/bin
mkdir -p %{buildroot}/usr/lib/systemd/system
mkdir -p %{buildroot}/%{_sharedstatedir}/flightctl
mkdir -p %{buildroot}/usr/lib/greenboot/check/required.d
install -m 0755 packaging/greenboot/flightctl-agent-running-check.sh %{buildroot}/usr/lib/greenboot/check/required.d/20_check_flightctl_agent.sh
cp bin/flightctl-agent %{buildroot}/usr/bin
cp packaging/must-gather/flightctl-must-gather %{buildroot}/usr/bin
cp packaging/systemd/flightctl-agent.service %{buildroot}/usr/lib/systemd/system
bin/flightctl completion bash > flightctl-completion.bash
install -Dpm 0644 flightctl-completion.bash -t %{buildroot}/%{_datadir}/bash-completion/completions/flightctl-completion.bash
bin/flightctl completion fish > flightctl-completion.fish
install -Dpm 0644 flightctl-completion.fish -t %{buildroot}/%{_datadir}/fish/vendor_completions.d/flightctl-completion.fish
bin/flightctl completion zsh > _flightctl-completion
install -Dpm 0644 _flightctl-completion -t %{buildroot}/%{_datadir}/zsh/site-functions/_flightctl-completion

%files
/usr/bin/flightctl
%{_datadir}/bash-completion/completions/flightctl-completion.bash
%{_datadir}/fish/vendor_completions.d/flightctl-completion.fish
%{_datadir}/zsh/site-functions/_flightctl-completion

%files agent
/usr/bin/flightctl-agent
/usr/bin/flightctl-must-gather
/usr/lib/systemd/system/flightctl-agent.service
%{_sharedstatedir}/flightctl
/usr/lib/greenboot/check/required.d/20_check_flightctl_agent.sh

%changelog
* Wed Oct 16 2024 Packit <hello@packit.dev> - v0.2.1-5.20241016072041382296.pr588.176.gffc19a8
- EDM-601: Improve deployment experience on Kind (rawagner)
- EDM-463: Enable flightctl-api access to to ingress (#551) (Miguel Angel Ajo Pelayo)
- NO-ISSUE: fix nodeports references and prometheus default (Miguel Angel Ajo Pelayo)
- NO-ISSUE: Cleanup helm install details (#574) (Miguel Angel Ajo Pelayo)
- NO-ISSUE: Fix Prometheus Nodeport in Kind (#585) (vraiti)
- NO-ISSUE: Fix helm error on acm install (Miguel Angel Ajo)
- EDM-588: Fix link to UI and pass insecureSkipVerify flag for auth config (rawagner)
- NO-ISSUE: Move device/fleet spec comparison methods to api (Avishay Traeger)
- EDM-240: plumb applications API (#572) (Sam Batschelet)
- EDM-447: Add fleet policy in openapi (Ori Amizur)
- EDM-571: Support for setuid/setgid/sticky bits in inline config (Avishay Traeger)
- EDM-485: Update smoke test sim cmd (Dakota Crowder)
- NO-ISSUE: ensure enrollemnt requests are retried (#576) (Sam Batschelet)
- EDM-573: Run helm dependency build in release job (rawagner)
- MGMT-18708: use client-enrollment as name (Miguel Angel Ajo Pelayo)
- MGMT-18708: Retry API login and reduce agent intervals (Miguel Angel Ajo Pelayo)
- MGMT-17725: Align Prometheus components with values.kind.yaml (vraiti)
- MGMT-17725: Fix instrumentation audit workers (vraiti)
- MGMT-18708: Add certificate request command to CI (Lily Sturmann)
- MGMT-18708: Add single CLI command to obtain enrollment cert (Lily Sturmann)
- MGMT-18708: Add auto-approval for enrollment certificates (Lily Sturmann)
- MGMT-18708: Add 'enrollment' as valid signer (Lily Sturmann)
- MGMT-18708: Add handling for encrypted keys (Lily Sturmann)
- MGMT-17673: add image building docs (Frank A. Zdarsky)
- EDM-555: add resource monitor API validation (#563) (Sam Batschelet)
- EDM-567: Do not trigger full tests on docs changes (Frank A. Zdarsky)
- Reduce backoff durations and log slow API requests (#564) (Sam Batschelet)
- EDM-554: e2e images: enable podman.service (#562) (Sam Batschelet)
- MGMT-18458: EDM-295: EDM-296: Simplify helm charts and add UI helm chart as dependency (rawagner)
- EDM-563: Fleet list API should return device count only on demand (Avishay Traeger)
- EDM-546: Fix device spec comparisons (Avishay Traeger)
- EDM-511: Provide script to generate endpoint environment variables (Miguel Angel Ajo)
- MGMT-17725: Add Prometheus observability to Flightctl (vraiti)
- EDM-485: Add label arg for devices created by the device simulator (Dakota Crowder)
- MGMT-17725: Add observability instrumentation to flightctl API server (Vance Raiti)
- EDM-541: Move developer docs (#560) (Frank Zdarsky)
- EDM-540: Fix validateAgainstSchema causing 400 errors on non-nullable required status fields (asafbss)
- EDM-519: add better handling of obsolete files (#547) (Sam Batschelet)
- NO-ISSUE: Enable LTO to reduce binary size (Miguel Angel Ajo Pelayo)
- EDM-506: Enable static builds for CLI (#552) (Miguel Angel Ajo Pelayo)
- NO-ISSUE: Align openapi descriptions and user docs (Avishay Traeger)
- NO-ISSUE: Move GRPC consts to separate package (Avishay Traeger)
- EDM-455: Simplify inline config API (Avishay Traeger)
- NO-ISSUE: Remove gorm dep from flterrors (Avishay Traeger)
- EDM-458: Refine names and minor adjustments (asafbss)
- EDM-458: Suppress gocyclo lint warning for printTable function (asafbss)
- EDM-458: adapt integration tests for summary and type changes (asafbss)
- EDM-458: add support for SummaryOnly for listDevices API (asafbss)
- EDM-458: temporary adapt  the cli to support devices summary (asafbss)
- EDM-458: return 400 on limit error (asafbss)
- EDM-458: fix retrieving devices' statuses by kind fleet (asafbss)
- EDM-458: adding devices summary API (asafbss)
- EDM-427: Remove yaml dep (Dakota Crowder)
- EDM-427: Change yaml unmarshal when reading bootc status to use json (Dakota Crowder)
- EDM-427: Remove log (Dakota Crowder)
- MGMT-17672: Adding device and fleet management sections (Frank A. Zdarsky)
- EDM-427: Add additional test cases (Dakota Crowder)
- EDM-427: Scaffold tests for IsOsImageReconciled (Dakota Crowder)
- EDM-427: Modify IsOsImageReconciled to use target in its comparison (Dakota Crowder)
- NO-ISSUE: fix CLI version output (Frank A. Zdarsky)
- NO-ISSUE: more detailed CLI version info (Frank A. Zdarsky)
- EDM-427: Fix spelling err, add image digest status update to system info exporter (Dakota Crowder)
- EDM-507: Add -o wide to device table (Frank A. Zdarsky)
- EDM-427: Add setting diget in SetOSImage (Dakota Crowder)
- NO-ISSUE: Bump gorm.io/driver/postgres from 1.5.7 to 1.5.9 (dependabot[bot])
- EDM-427: Send image digest as a part of device os status update during bootstrap (Dakota Crowder)
- EDM-427: Add test cases with port (Dakota Crowder)
- EDM-299: make iamge required for ImageApplicationProvider (Sam Batschelet)
- EDM-299: add validation for applications API (Sam Batschelet)
- EDM-427: Use regex definition to parse imageinto base, tag, and digest (Dakota Crowder)
- EDM-427: Remove image type, add simple method for converting image to bootc target before swtich is called (Dakota Crowder)
- EDM-427: fix linting issue in test (Dakota Crowder)
- EDM-427: Report current booted os image digest when updating the device os status (Dakota Crowder)
- EDM-427: Fix bootstrap test (Dakota Crowder)
- EDM-427: remove imageDigest from spec, shift around some code in image package (Dakota Crowder)
- EDM-299: add device applications API (#441) (Sam Batschelet)
- EDM-452: Ensure tag releases for cli, stop recreating (Miguel Angel Ajo Pelayo)
- EDM-452: Ensure plain version tags for releases (Miguel Angel Ajo Pelayo)
- EDM-427: Separate out image pkg (Dakota Crowder)
- EDM-427: remove isOsSame (Dakota Crowder)
- EDM-427: update ensureImage flow to use Image type (Dakota Crowder)
- EDM-427: update checkRollback and IsRollingBack (Dakota Crowder)
- EDM-427: fix IsIOSUpdate, add bootc status to image func and update CheckOsRec (Dakota Crowder)
- EDM-427: add areImagesEquivalent func (Dakota Crowder)
- EDM-427: begin working towards shared Image struct intermediary to make comparisons between device os specs and bootc state easier to reason about (Dakota Crowder)
- EDM-462: refactored the tests to use testify suite through "go test". (Amir Yogev)
- EDM-462: dropped check for nil message + renamed console creation. (Amir Yogev)
- EDM-427: add imageDigest to device os spec and status, use optional digests in IsOSUpdate (Dakota Crowder)
- EDM-462: keep using bash as a test command and refined test cases with mock setup. (Amir Yogev)
- EDM-456: Update allowed callback urls in Kind deployment (#533) (Rastislav Wagner)
- EDM-462: not using bash as a test command + mock StreamClient.Recv(). (Amir Yogev)
- EDM-462: adding unit tests for console.go. (Amir Yogev)
- MGMT-18490: Add shell completion to CLI RPM (Vance Raiti)
- EDM-373: Style adjustments to getRenderedVersion (Dakota Crowder)
- EDM-373: Style adjustments to getNextRenderedVersion (Dakota Crowder)
- EDM-373: Style adjustments for pathFromType (Dakota Crowder)
- EDM-373: Fix spelling mistakes (Dakota Crowder)
- EDM-373: Remove a test case and consolidate logic (Dakota Crowder)
- EDM-373: Address linting issues w/ spec file (Dakota Crowder)
- EDM-373: Slight adjustments / cleanup for some tests (Dakota Crowder)
- EDM-373: Additional cases for GetDesired (Dakota Crowder)
- EDM-373: Begin adding tests for GetDesired (Dakota Crowder)
- EDM-352: Add flow chart of for tasks in docs (Avishay Traeger)
- EDM-373: Add tests around request to get spec (Dakota Crowder)
- EDM-373: Add test cases for pathFromType, getNextRenderedVersion, getRenderedVersion (Dakota Crowder)
- EDM-373: Add tests for IsUpdating (Dakota Crowder)
- EDM-373: Add tests for Rollback and SetClient (Dakota Crowder)
- EDM-373: Write tests for PrepareRollback (Dakota Crowder)

* Wed Aug 21 2024 Sam Batschelet <sbatsche@redhat.com> - 0.0.1-5
- Add must-gather script to provide a simple mechanism to collect agent debug
* Wed Aug 7 2024 Sam Batschelet <sbatsche@redhat.com> - 0.0.1-4
- Add basic greenboot support for failed flightctl-agent service 
* Wed Mar 13 2024 Ricardo Noriega <rnoriega@redhat.com> - 0.0.1-3
- New specfile for both CLI and agent packages
